<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::entropy_encoder_kernel_1 Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1entropy__encoder__kernel__1.html">entropy_encoder_kernel_1</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1entropy__encoder__kernel__1-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::entropy_encoder_kernel_1 Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a321e1db34f202687937d724f01e0e026"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__kernel__1.html#a321e1db34f202687937d724f01e0e026">entropy_encoder_kernel_1</a> ()</td></tr>
<tr class="separator:a321e1db34f202687937d724f01e0e026"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2787f8a2397712249967561508ade118"><td class="memItemLeft" align="right" valign="top"><a id="a2787f8a2397712249967561508ade118"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a2787f8a2397712249967561508ade118"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af89d628ebdb68983cc417c6c014bcbe0"><td class="memItemLeft" align="right" valign="top"><a id="af89d628ebdb68983cc417c6c014bcbe0"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_stream</b> (std::ostream &amp;out)</td></tr>
<tr class="separator:af89d628ebdb68983cc417c6c014bcbe0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca519412cbb74ae930def606c72c623d"><td class="memItemLeft" align="right" valign="top"><a id="aca519412cbb74ae930def606c72c623d"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>stream_is_set</b> () const</td></tr>
<tr class="separator:aca519412cbb74ae930def606c72c623d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56979aeafbfde289690b21fd670ed667"><td class="memItemLeft" align="right" valign="top"><a id="a56979aeafbfde289690b21fd670ed667"></a>
std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>get_stream</b> () const</td></tr>
<tr class="separator:a56979aeafbfde289690b21fd670ed667"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a098b1595fc03b4b13e6daf3ff49336c3"><td class="memItemLeft" align="right" valign="top"><a id="a098b1595fc03b4b13e6daf3ff49336c3"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>encode</b> (uint32 low_count, uint32 high_count, uint32 total)</td></tr>
<tr class="separator:a098b1595fc03b4b13e6daf3ff49336c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a8b7c8443bcbb79dd62600fc05b1b641e"><td class="memItemLeft" align="right" valign="top"><a id="a8b7c8443bcbb79dd62600fc05b1b641e"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>flush</b> ()</td></tr>
<tr class="separator:a8b7c8443bcbb79dd62600fc05b1b641e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d65e4b0c0b2746691d87ef22ecd9258"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__kernel__1.html#a4d65e4b0c0b2746691d87ef22ecd9258">entropy_encoder_kernel_1</a> (<a class="el" href="classdlib_1_1entropy__encoder__kernel__1.html">entropy_encoder_kernel_1</a> &amp;)</td></tr>
<tr class="separator:a4d65e4b0c0b2746691d87ef22ecd9258"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9f9a81da175ad86d8992520b4a3e230"><td class="memItemLeft" align="right" valign="top"><a id="ae9f9a81da175ad86d8992520b4a3e230"></a>
<a class="el" href="classdlib_1_1entropy__encoder__kernel__1.html">entropy_encoder_kernel_1</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1entropy__encoder__kernel__1.html">entropy_encoder_kernel_1</a> &amp;)</td></tr>
<tr class="separator:ae9f9a81da175ad86d8992520b4a3e230"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a99c38b9a4c863bc02ada8674335a603f"><td class="memItemLeft" align="right" valign="top"><a id="a99c38b9a4c863bc02ada8674335a603f"></a>
const uint32&#160;</td><td class="memItemRight" valign="bottom"><b>initial_low</b></td></tr>
<tr class="separator:a99c38b9a4c863bc02ada8674335a603f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab348d27991a73e79051ac78535bf6087"><td class="memItemLeft" align="right" valign="top"><a id="ab348d27991a73e79051ac78535bf6087"></a>
const uint32&#160;</td><td class="memItemRight" valign="bottom"><b>initial_high</b></td></tr>
<tr class="separator:ab348d27991a73e79051ac78535bf6087"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a95dac968aec1bd9fbae46ed07a3f9467"><td class="memItemLeft" align="right" valign="top"><a id="a95dac968aec1bd9fbae46ed07a3f9467"></a>
std::ostream *&#160;</td><td class="memItemRight" valign="bottom"><b>out</b></td></tr>
<tr class="separator:a95dac968aec1bd9fbae46ed07a3f9467"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4a2fdcd558411e948b0fac8ad8b37601"><td class="memItemLeft" align="right" valign="top"><a id="a4a2fdcd558411e948b0fac8ad8b37601"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>low</b></td></tr>
<tr class="separator:a4a2fdcd558411e948b0fac8ad8b37601"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a031a6a318823a09353757e18691a5284"><td class="memItemLeft" align="right" valign="top"><a id="a031a6a318823a09353757e18691a5284"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>high</b></td></tr>
<tr class="separator:a031a6a318823a09353757e18691a5284"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa29bf8adb522969dce498686f98de3d8"><td class="memItemLeft" align="right" valign="top"><a id="aa29bf8adb522969dce498686f98de3d8"></a>
unsigned char&#160;</td><td class="memItemRight" valign="bottom"><b>buf</b></td></tr>
<tr class="separator:aa29bf8adb522969dce498686f98de3d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a62aa8401ba5fff1a5403a87c6ce657e9"><td class="memItemLeft" align="right" valign="top"><a id="a62aa8401ba5fff1a5403a87c6ce657e9"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>buf_used</b></td></tr>
<tr class="separator:a62aa8401ba5fff1a5403a87c6ce657e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ee0814e28a616aa543a42aa4b07ff69"><td class="memItemLeft" align="right" valign="top"><a id="a8ee0814e28a616aa543a42aa4b07ff69"></a>
std::streambuf *&#160;</td><td class="memItemRight" valign="bottom"><b>streambuf</b></td></tr>
<tr class="separator:a8ee0814e28a616aa543a42aa4b07ff69"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a321e1db34f202687937d724f01e0e026"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a321e1db34f202687937d724f01e0e026">&#9670;&nbsp;</a></span>entropy_encoder_kernel_1() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dlib::entropy_encoder_kernel_1::entropy_encoder_kernel_1 </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">GENERAL NOTES
    this encoder is implemented using arithmetic coding

INITIAL VALUE
    out      == 0
    buf_used == 0
    buf      == 0
    initial_low      == 0x00000001  (slightly more than zero)
    initial_high     == 0xffffffff  (slightly less than one, 0.99999999976717)
    low      == initial_low
    high     == initial_high

CONVENTION
    if (out != 0)
         out      == get_stream()
        true      == stream_is_set()
        streambuf == out-&gt;rdbuf()
    else
        false     == stream_is_set()

    buf      == used to accumulate bits before writing them to out.  
    buf_used == the number of low order bits in buf that are currently 
                in use
    low      == the low end of the range used for arithmetic encoding.
                this number is used as a 32bit fixed point real number. 
                the point is fixed just before the first bit, so it is
                always in the range [0,1)

                low is also never allowed to be zero to avoid overflow
                in the calculation (high-low+1)/total.

    high     == the high end of the range - 1 used for arithmetic encoding.
                this number is used as a 32bit fixed point real number. 
                the point is fixed just before the first bit, so when we
                interpret high as a real number then it is always in the
                range [0,1)

                the range for arithmetic encoding is always 
                [low,high + 0.9999999...)   the 0.9999999... is why
                high == real upper range - 1         
</pre><p>! </p>

</div>
</div>
<a id="a4d65e4b0c0b2746691d87ef22ecd9258"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4d65e4b0c0b2746691d87ef22ecd9258">&#9670;&nbsp;</a></span>entropy_encoder_kernel_1() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">dlib::entropy_encoder_kernel_1::entropy_encoder_kernel_1 </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1entropy__encoder__kernel__1.html">entropy_encoder_kernel_1</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    out != 0 (i.e.  there is a stream object to flush the data to 
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="entropy__encoder__kernel__1_8h_source.html">entropy_encoder_kernel_1.h</a></li>
<li>entropy_encoder_kernel_1.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
